#!/usr/bin/perl
use Mysql;

#    PollWorld SQL v1.3 - poll management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<pw.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
print "HTTP/1.0 200 OK\n";
print "content-type: text/html\n\n";

$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$date="0$date" if (length($date)==1);
$month=$cal{$month};
$month="0$month" if (length($month)==1);
$nowdate="$year-$month-$date";
if ($ENV{CONTENT_LENGTH}>0){sysread(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}="$data{$field},$value";}
		else {$data{$field}=$value;}
	}
}
@data=split("; ",$ENV{HTTP_COOKIE});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cookie{$field}=$value;
	}
}
if (!$data{id} || !$data{uid})
{
print qq~document.write('<table width=$twidth border=1 bordercolor="#7A0000" cellpadding=0>');
document.write('<tr><td>WRONG POLL HTML CODE</td></tr>');
document.write('</table>');
~;
&closedb;
exit;
}
$sth=$dbh->query("LOCK TABLES pw_polls READ") if ($locktables);
$sth=$dbh->query("SELECT pid,question,rdig,delay,expdate,type FROM pw_polls WHERE (pid=$data{id} AND uid=$data{uid})");
($pid,$question,$cook,$tlim,$expdate,$type)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($pid)
{
print qq~document.write('<table width=$twidth border=1 bordercolor="#7A0000" cellpadding=0>');
document.write('<tr><td>UNKNOWN POLL</td></tr>');
document.write('</table>');
~;
&closedb;
exit;
}
$sth=$dbh->query("LOCK TABLES pw_polls READ") if ($locktables);
$sth=$dbh->query("SELECT pid FROM pw_polls WHERE (pid=$data{id} AND uid=$data{uid} AND (expdate>'$nowdate' || expdate='0000-00-00'))");
$pid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&result unless ($pid);
$temp="pollworld$data{uid}\_$data{id}";
&result if ($cookie{$temp}==$cook && $cook);
if ($tlim)
{
$ip=$ENV{REMOTE_ADDR};
$nowdate.=" $time";
$sth=$dbh->query("LOCK TABLES pw_ip_$data{uid} WRITE") if ($locktables);
$sth=$dbh->query("SELECT ipid FROM pw_ip_$data{uid} WHERE (pid=$data{id} AND ip='$ip' AND expdt>'$nowdate')");
$ipid=$sth->fetchrow;
if ($ipid)
{
	$nottoshow=1;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&result if ($nottoshow);
$sth=$dbh->query("LOCK TABLES pw_stats_$data{uid} READ") if ($locktables);
$sth=$dbh->query("SELECT aid,answer FROM pw_stats_$data{uid} WHERE pid=$data{id}");
while (($aid,$anm)=$sth->fetchrow)
{
	if ($type==1)
	{
	if (!$checked)
	{
		$menu=qq~<tr><td><font size=1><input type=radio checked name=variant value=$aid> $anm</font></td></tr>\n~;
		$checked=1;
	}
	else {$menu.=qq~<tr><td><font size=1><input type=radio name=variant value=$aid> $anm</font></td></tr>\n~;}
	}
	else
	{
		$menu.=qq~<option value="$aid">$anm</option>\n~;
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($type==2){$menu=qq~<tr><td><select name=variant>$menu</select></td></tr>\n~;}
open (F,"<$pwpath/template/banner.tpl");
flock(F,$LOCK_EX);
$bannercall=<F>;
flock(F,$LOCK_UN);
close(F);
open (F,"<$pwpath/template/code.tpl");
flock(F,$LOCK_EX);
@code=<F>;
flock(F,$LOCK_UN);
close(F);
$code=join("",@code);
$bannercall=~s/\'/\\\'/g;
$code=~s/\@/\\\@/g;
$code=~s/\~/\\\~/g;
$code="\$forma=qq~$code~;";
eval $code;
$forma=~s/\'/\\\'/g;
$forma=~s/APOSTROPHH/\\\'/g;
$forma=~s/#HERE#/\'/g;
print qq~var jscurloc=document.location;\n~;
@forma=split("\n",$forma);
foreach(@forma)
{
print qq~document.write('$_');\n~;
}

sub result
{
open (F,"<$pwpath/template/banner.tpl");
flock(F,$LOCK_EX);
$bannercall=<F>;
flock(F,$LOCK_UN);
close(F);
$bannercall=~s/\'/\\\'/g;
$question=~s/APOSTROPHH/\\\'/g;
$sth=$dbh->query("LOCK TABLES pw_stats_$data{uid} READ") if ($locktables);
$sth=$dbh->query("SELECT SUM(hits) FROM pw_stats_$data{uid} WHERE pid=$data{id}");
$sum=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sum=0 unless ($sum);
print qq~document.write('<table width=$twidth border=1 bordercolor="#7A0000" cellpadding=0>');
document.write('<tr><td>$bannercall</td></tr>');
document.write('<tr><td bgcolor="#7A0000"><font color=white size=2><b>$question</b></font></td></tr>');
~;
$sth=$dbh->query("LOCK TABLES pw_stats_$data{uid} READ") if ($locktables);
$sth=$dbh->query("SELECT aid,answer,hits FROM pw_stats_$data{uid} WHERE pid=$data{id}");
while (($id,$pname,$hits)=$sth->fetchrow)
{
	if ($sum){$vote=int($hits/$sum*100);}
	else {$vote=0;}
	$width=$vote;
	$width=1 if ($width==0);
	$xwidth=100-$width;
	$xwidth=1 if ($xwidth==0);
	$pname=~s/APOSTROPHH/\\\'/g;
	print qq~document.write('<tr><td><font size=1><b>$pname</b></font><br><img src="$pollworld/images/chartbar.gif" width="$width" height="10"><img src="$pollworld/images/blankbar.gif" width="$xwidth" height="10"><font size=2 color="#7A0000"><b> $hits ($vote %)</b></font></td></tr>');\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
print qq~document.write('<tr><td bgcolor="#7A0000" align=center><font size=2 color=white><b>Total votes: $sum</b></td></tr></table>');
~;
exit;
}
sub closedb
{
$sth="";
$dbh="";
}
