#!/usr/bin/perl
use Mysql;

#    PollWorld SQL v1.3 - poll management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<pw.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);
if ($ENV{CONTENT_LENGTH}>0){sysread(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}="$data{$field},$value";}
		else {$data{$field}=$value;}
	}
}
$destination=$data{method};
$destination="stats" unless ($destination);

$sth=$dbh->query("LOCK TABLES pw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid FROM pw_users WHERE (username='$data{name}' AND password='$data{password}')");
$uid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($uid)
{
	&closedb;
	open (F,"<$pwpath/template/errauth.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage=~s/\@/\\\@/g;
	$htmlpage=~s/\~/\\\~/g;
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
&$destination;

sub stats
{
$sth=$dbh->query("LOCK TABLES pw_polls READ") if ($locktables);
$sth=$dbh->query("SELECT pid,title FROM pw_polls WHERE uid=$uid");
while (($pid,$title)=$sth->fetchrow)
{
	$title=~s/APOSTROPHH/'/g;
	unless ($first){$first=$pid;$second=$title;}
	$pollnames=$title if ($data{poll}==$pid);
	$polls.=qq~<option value="$pid">$title</option>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($polls)
{
$data{poll}=$first if (!$data{poll});
$pollnames=$second if (!$pollnames);
$sth=$dbh->query("LOCK TABLES pw_polls READ") if ($locktables);
$sth=$dbh->query("SELECT question FROM pw_polls WHERE pid=$data{poll}");
$question=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$question=~s/APOSTROPHH/'/g;
$sth=$dbh->query("LOCK TABLES pw_stats_$uid READ") if ($locktables);
$sth=$dbh->query("SELECT SUM(hits) FROM pw_stats_$uid WHERE pid=$data{poll}");
$sum=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sum=0 unless ($sum);
$sth=$dbh->query("LOCK TABLES pw_stats_$uid READ") if ($locktables);
$sth=$dbh->query("SELECT aid,answer,hits FROM pw_stats_$uid WHERE pid=$data{poll}");
while (($id,$pname,$hits)=$sth->fetchrow)
{
	if ($sum){$vote=int($hits/$sum*100);}
	else {$vote=0;}
	$pname=~s/APOSTROPHH/'/g;
	$result.=qq~<tr><td width="60%" bgcolor="#C0C0C0" valign="top"><font size=2><b>$pname</b></font></td><td width="40%" align="right" bgcolor="#C0C0C0"><font size=2>$vote %<br>($hits votes)</font></td></tr>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
open (F,"<$pwpath/template/mstats.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
&closedb;
open (F,"<$pwpath/template/mstats2.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub code
{
$sth=$dbh->query("LOCK TABLES pw_polls READ") if ($locktables);
$sth=$dbh->query("SELECT pid,title FROM pw_polls WHERE uid=$uid");
while (($pid,$title)=$sth->fetchrow)
{
	$title=~s/APOSTROPHH/'/g;
	unless ($first){$first=$pid;$second=$title;}
	$pollnames=$title if ($data{poll}==$pid);
	$polls.=qq~<option value="$pid">$title</option>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($polls)
{
$data{poll}=$first if (!$data{poll});
$pollnames=$second if (!$pollnames);
&closedb;
open (F,"<$pwpath/template/mcode.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
&closedb;
open (F,"<$pwpath/template/mcode2.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub mmpoll
{
$sth=$dbh->query("LOCK TABLES pw_polls READ") if ($locktables);
$sth=$dbh->query("SELECT pid,title FROM pw_polls WHERE uid=$uid");
while (($pid,$title)=$sth->fetchrow)
{
	$title=~s/APOSTROPHH/'/g;
	unless ($first){$first=$pid;$second=$title;}
	$pollnames=$title if ($data{poll}==$pid);
	$polls.=qq~<option value="$pid">$title</option>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
open (F,"<$pwpath/template/mmpoll.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub new
{
$rdig=int(rand(99999999));
$data{poll}=~s/'/APOSTROPHH/g;
$data{question}=~s/'/APOSTROPHH/g;
$sth=$dbh->query("LOCK TABLES pw_polls WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO pw_polls (uid,title,question,rdig,delay,expdate,type) VALUES ($uid,'$data{poll}','$data{question}',$rdig,$delay,'$data{year}-$data{month}-$data{date}',$data{polltype})");
$sth=$dbh->query("SELECT LAST_INSERT_ID()");
$pid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$data{poll}=~s/APOSTROPHH/'/g;
$data{question}=~s/APOSTROPHH/'/g;
$sth=$dbh->query("LOCK TABLES pw_stats_$uid WRITE") if ($locktables);
@answers=split("\r\n",$data{answers});
foreach(@answers)
{
	$_=~s/'/APOSTROPHH/g;
	$sth=$dbh->query("INSERT INTO pw_stats_$uid (pid,answer,hits) VALUES ($pid,'$_',0)");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES pw_stats_$uid READ") if ($locktables);
$sth=$dbh->query("SELECT aid,answer FROM pw_stats_$uid WHERE pid=$pid");
while (($i,$_)=$sth->fetchrow)
{
	$_=~s/APOSTROPHH/'/g;
	if ($data{polltype}==1)
	{
	if (!$checked)
	{
		$menu=qq~<tr><td><font size=1><input type=radio checked name=variant value=$i> $_</font></td></tr>\n~;
		$checked=1;
	}
	else {$menu.=qq~<tr><td><font size=1><input type=radio name=variant value=$i> $_</font></td></tr>\n~;}
	}
	else
	{
		$menu.=qq~<option value="$i">$_</option>\n~;
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($data{polltype}==2){$menu=qq~<tr><td><select name=variant>$menu</select></td></tr>\n~;}
$data{id}=$pid;
$question=$data{question};
open (F,"<$pwpath/template/banner.tpl");
flock(F,$LOCK_EX);
$bannercall=<F>;
flock(F,$LOCK_UN);
close(F);
open (F,"<$pwpath/template/democode.tpl");
flock(F,$LOCK_EX);
@code=<F>;
flock(F,$LOCK_UN);
close(F);
$code=join("",@code);
$code=~s/\@/\\\@/g;
$code=~s/\~/\\\~/g;
$code="\$forma=qq~$code~;";
eval $code;
&closedb;
open (F,"<$pwpath/template/mmnew.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub remove
{
if ($data{poll})
{
$sth=$dbh->query("LOCK TABLES pw_polls WRITE, pw_stats_$uid WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM pw_polls WHERE (pid=$data{poll} AND uid=$uid)");
$sth=$dbh->query("DELETE FROM pw_stats_$uid WHERE pid=$data{poll}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&mmpoll;
}
sub edit
{
if ($data{poll})
{
$sth=$dbh->query("LOCK TABLES pw_polls READ") if ($locktables);
$sth=$dbh->query("SELECT question,rdig,delay,expdate,type FROM pw_polls WHERE (pid=$data{poll} AND uid=$uid)");
($question,$cookie,$iprest,$expdate,$polltype)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$question=~s/APOSTROPHH/'/g;
$sth=$dbh->query("LOCK TABLES pw_stats_$uid READ") if ($locktables);
$sth=$dbh->query("SELECT aid,answer FROM pw_stats_$uid WHERE pid=$data{poll}");
while (($id,$pname)=$sth->fetchrow)
{
	$pname=~s/APOSTROPHH/'/g;
	if ($polltype==1)
	{
	if (!$checked)
	{
		$menu=qq~<tr><td><font size=1><input type=radio checked name=variant value=$id> $pname</font></td></tr>\n~;
		$checked=1;
	}
	else {$menu.=qq~<tr><td><font size=1><input type=radio name=variant value=$id> $pname</font></td></tr>\n~;}
	}
	else
	{
		$menu.=qq~<option value="$id">$pname</option>\n~;
	}
	$answers.=qq~<option value="$id">$pname</option>~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($polltype==2){$menu=qq~<tr><td><select name=variant>$menu</select></td></tr>\n~;}
$data{id}=$data{poll};
$selected[$polltype]="selected";
if (!$cookie)
{
	$cookie="nocookie";
	srand;
	$iscookie=int(rand(99999999));
}
else
{
	$iscookie=$cookie;
}
$selected{$cookie}="selected";
($year,$month,$date)=split("-",$expdate);
$year="" if ($year eq "0000");
$month="" if ($month eq "00");
$date="" if ($date eq "00");
open (F,"<$pwpath/template/banner.tpl");
flock(F,$LOCK_EX);
$bannercall=<F>;
flock(F,$LOCK_UN);
close(F);
open (F,"<$pwpath/template/democode.tpl");
flock(F,$LOCK_EX);
@code=<F>;
flock(F,$LOCK_UN);
close(F);
$code=join("",@code);
$code=~s/\@/\\\@/g;
$code=~s/\~/\\\~/g;
$code="\$forma=qq~$code~;";
eval $code;
&closedb;
open (F,"<$pwpath/template/mmedit.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
else {&mmpoll;}
}
sub chset
{
$data{cookiecheck}="NULL" if ($data{cookiecheck} eq "nocookie");
$data{dely}="0" unless ($data{dely});
$sth=$dbh->query("LOCK TABLES pw_polls WRITE") if ($locktables);
$sth=$dbh->query("UPDATE pw_polls SET rdig=$data{cookiecheck},delay=$data{dely},expdate='$data{year}-$data{month}-$data{date}',type=$data{polltype} WHERE (pid=$data{poll} AND uid=$uid)");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&edit;
}
sub chquest
{
$data{question}=~s/'/APOSTROPHH/g;
$sth=$dbh->query("LOCK TABLES pw_polls WRITE") if ($locktables);
$sth=$dbh->query("UPDATE pw_polls SET question='$data{question}' WHERE (pid=$data{poll} AND uid=$uid)");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&edit;
}
sub addans
{
$data{ans}=~s/'/APOSTROPHH/g;
$sth=$dbh->query("LOCK TABLES pw_stats_$uid WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO pw_stats_$uid (pid,answer,hits) VALUES ($data{poll},'$data{ans}',0)");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&edit;
}
sub chans
{
if ($data{ans})
{
$data{answ}=~s/'/APOSTROPHH/g;
$sth=$dbh->query("LOCK TABLES pw_stats_$uid WRITE") if ($locktables);
$sth=$dbh->query("UPDATE pw_stats_$uid SET answer='$data{answ}' WHERE aid=$data{ans}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&edit;
}
sub deans
{
if ($data{ans})
{
$sth=$dbh->query("LOCK TABLES pw_stats_$uid WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM pw_stats_$uid WHERE aid=$data{ans}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&edit;
}
sub rstat
{
srand;
$rndm=int(rand(99999999));
$sth=$dbh->query("LOCK TABLES pw_polls WRITE") if ($locktables);
$sth=$dbh->query("SELECT rdig FROM pw_polls WHERE (pid=$data{poll} AND uid=$uid)");
$cookie=$sth->fetchrow;
if ($cookie){$cookie=$rndm;}
else {$cookie="NULL";}
$sth=$dbh->query("UPDATE pw_polls SET rdig=$cookie WHERE (pid=$data{poll} AND uid=$uid)");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES pw_stats_$uid WRITE") if ($locktables);
$sth=$dbh->query("UPDATE pw_stats_$uid SET hits=0 WHERE pid=$data{poll}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES pw_ip_$uid WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM pw_ip_$uid WHERE pid=$data{poll}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&edit;
}
sub closedb
{
$sth="";
$dbh="";
}
