#!/usr/bin/perl
use Mysql;

#    PollWorld SQL v1.3 - poll management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<pw.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);
sysread (STDIN,$query,$ENV{CONTENT_LENGTH});
@query=split("&",$query);
foreach (@query)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9A-Fa-f]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}.=",$value";}
		else {$data{$field}=$value;}
	}
}
if (!$data{Username})
{
	$errors.="Illegal script using<br>\n";
	&closedb;
	open (F,"<$pwpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage=~s/\@/\\\@/g;
	$htmlpage=~s/\~/\\\~/g;
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$sth=$dbh->query("LOCK TABLES pw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid FROM pw_users WHERE username='$data{Username}'");
$uid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($uid)
{
	$errors.="Username $data{Username} is <b>already in use</b>, please choose different<br>\n";
	&closedb;
	open (F,"<$pwpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage=~s/\@/\\\@/g;
	$htmlpage=~s/\~/\\\~/g;
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}

$sth=$dbh->query("LOCK TABLES pw_users WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO pw_users (username,password,email,status) VALUES ('$data{Username}','$data{Password}','$data{EMail}',0)");
$sth=$dbh->query("SELECT LAST_INSERT_ID()");
$uid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("CREATE TABLE pw_stats_$uid (aid MEDIUMINT(6) UNSIGNED NOT NULL auto_increment,pid MEDIUMINT(8) UNSIGNED NOT NULL,answer VARCHAR(255),hits MEDIUMINT(8),PRIMARY KEY (aid),INDEX (aid,pid))");
$sth=$dbh->query("CREATE TABLE pw_ip_$uid (ipid MEDIUMINT(6) UNSIGNED NOT NULL auto_increment,pid MEDIUMINT(8) UNSIGNED NOT NULL,ip VARCHAR(15),expdt DATETIME,PRIMARY KEY (ipid),INDEX (ip))");
open (F,"<$pwpath/mail/admin.hdr");
flock(F,$LOCK_EX);
@temp=<F>;
flock(F,$LOCK_UN);
close (F);
$header=join("",@temp);
open (F,"<$pwpath/mail/admin.btm");
flock(F,$LOCK_EX);
@temp=<F>;
flock(F,$LOCK_UN);
close (F);
$footer=join("",@temp);
open (MAIL,"|$progmail");
print MAIL "To: $email\n";
print MAIL "From: $data{EMail} ($data{Name})\n";
print MAIL "Subject: $owntitle - New User Information\n\n";
$ltime=scalar localtime; 
print MAIL $header;
print MAIL "E-mail: $data{EMail}\n";
print MAIL "Username: $data{Username}\n";
print MAIL "Password: $data{Password}\n";
print MAIL $footer;
print MAIL "\n.\n";
close (MAIL);
open (F,"<$pwpath/mail/user.hdr");
flock(F,$LOCK_EX);
@temp=<F>;
flock(F,$LOCK_UN);
close (F);
$header=join("",@temp);
open (F,"<$pwpath/mail/user.btm");
flock(F,$LOCK_EX);
@temp=<F>;
flock(F,$LOCK_UN);
close (F);
$footer=join("",@temp);
open (MAIL,"|$progmail");
print MAIL "To: $data{EMail}\n";
print MAIL "From: $email ($owntitle)\n";
print MAIL "Subject: Welcome to our voting system\n\n";
$ltime=scalar localtime; 
print MAIL $header;
print MAIL "Please login to members section and create voting forms and manage your account:\n\n";
print MAIL "URL: $pollworld/members.html\n";
print MAIL "Your login: $data{Username}\n";
print MAIL "Your password: $data{Password}\n\n";
print MAIL $footer;
print MAIL "\n.\n";
close (MAIL);

&closedb;
open (F,"<$pwpath/template/success.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;

sub error
{
open (F,"<$pwpath/template/error.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub closedb
{
$sth="";
$dbh="";
}
