#!/usr/bin/perl
use Mysql;

#    PollWorld SQL v1.3 - poll management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<pw.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);
sysread (STDIN,$query,$ENV{CONTENT_LENGTH});
@query=split("&",$query);
foreach (@query)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9A-Fa-f]{2})/pack('C',hex($1))/eg;
		$data{$field}=$value;
	}
}
open (F,"<$basepath/pollworld.pwd");
flock(F,$LOCK_EX);
@users=<F>;
flock(F,$LOCK_UN);
close (F);
$data{Username}=~tr/A-Z/a-z/;

unless ($data{EMail}=~/^[\w\-.]+\@{1}[\w\-.]+$/ && $data{EMail}=~/^\w+/ && $data{EMail}=~/\w+$/)
{
	$errors.="Incorrect <b>e-mail</b>, you must put your e-mail address<br>\n";
	$flag=1;
}
$sth=$dbh->query("LOCK TABLES pw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid FROM pw_users WHERE username='$data{Username}'");
$uid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($uid)
{
	$errors.="Username $data{Username} is <b>already in use</b>, please choose different<br>\n";
	$flag=1;
}
if ($data{Username}=~/\W+/ || $data{Username} eq "")
{
	$errors.="Incorrect <b>username</b>, must be one word<br>\n";
	$flag=1;
}
if ($data{Password}=~/\W+/ || $data{Password} eq "")
{
	$errors.="Incorrect <b>password</b>, must be one word<br>\n";
	$flag=1;
}
&error if ($flag);
&closedb;
open (F,"<$pwpath/template/confirm.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;

sub error
{
&closedb;
open (F,"<$pwpath/template/error.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub closedb
{
$sth="";
$dbh="";
}
